package exemplos;

import malhaFerroviaria.Ferrovia;

/**
 * Exemplo de uso do Simulador da malha ferroviria.
 * A classe Ferrovia  a 'fachada' (design pattern faade) para
 * as classes que implementam os elementos da malha ferroviria.
 * Ela tambm  implementa o pattern 'singleton': uma nica instncia
 * da ferrovia  criada.
 * Essa classe implementa a interface ControleFerrovia, que prev
 * a publicao dos mtodos necessrios para o Centro de Controle.
 * @author Vanini
 *
 */

public class Exemplo1 {

	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args){
		
		// 1 - Pegar a instncia nica da Ferrovia
		Ferrovia ferrovia = Ferrovia.getInstance();
		
		// 2 - Definir um cenrio para a simulao
		ferrovia.defineCenario(0);
		
		// 3 - Registrar os tratadores de evento
		ferrovia.registraTratadorDeEventos(new Console());
		
		// 4 - Rodar a simulao
		try{
			ferrovia.simularCenario(0, 10000);
		}catch(Exception ee){
			System.out.println("Exceo:"+ee.getClass().getName()+"::"+ee.getMessage());
			ee.printStackTrace();
		}
		System.out.println("*=*=*= Fim da Simulao =*=*=*");


	}

}
